/* TEKNISA

Nome: 7600_PMEPKGO_UTIL_CONSPLAN_PME.SQL

Descrio:0
Rotinas e cursores auxiliares para clculo do consumo planejado

Para aplicar e debugar
-- START @C:\Web_411\Sql\End_Conv\Oracle\7600_PMEPKGO_UTIL_CONSPLAN_PME

Criao:
20/05/2005 - Luiz Otvio de Souza

*/

CREATE OR REPLACE
PACKAGE UTIL_CONSPLAN_PME AS

   /* CURSOR PRINCIPAL  */
   TYPE CONSPLAN_PME_RECTYPE IS RECORD (
      DTDATA       DATA.DTDATA%TYPE,
      CDSERVFILI   SERVICO.CDSERVFILI%TYPE,
      HRINICATEN   SERVICO.HRINICATEN%TYPE,
      NRCARDAPIO   CARDADIA.NRCARDAPIO%TYPE,
      CDCLIENTE    CARDACLI.CDCLIENTE%TYPE,
      CDDESTFILI   CARDACLI.CDDESTFILI%TYPE,
      QTCOMESTICAR CARDADIA.QTCOMESTICAR%TYPE,
      CDFILIAL     FILIAL.CDFILIAL%TYPE);

   TYPE CONSPLAN_PME_CURTYPE IS REF CURSOR RETURN CONSPLAN_PME_RECTYPE;

   /* COMPOSICAO DO CARDAPIO DO DIA */
   TYPE COMPCARD_PME_RECTYPE IS RECORD (
      CDFILAUXPRAT COMPCARD.CDFILAUXPRAT%TYPE,
      CDPRATO      COMPCARD.CDPRATO%TYPE,
      VRPECONSCARD COMPCARD.VRPECONSCARD%TYPE,
     /* NRSEQPRATCAR COMPCARD.NRSEQPRATCAR%TYPE,*/
      CDTIPOPRAT   COMPCARD.CDTIPOPRAT%TYPE,
      CDSETORCOZ   SETOTIPOPRAT.CDSETORCOZ%TYPE);

   TYPE COMPCARD_PME_CURTYPE IS REF CURSOR RETURN COMPCARD_PME_RECTYPE;

   /* PRODUTOS DO PRATO */
   TYPE PRODPRAT_PME_RECTYPE IS RECORD (
      CDPRODUTO  PRODUTO.CDPRODUTO%TYPE,
      QTPRODUTO  NUMBER(20, 08),
      SGUNIDADE  PRODUTO.SGUNIDADE%TYPE,
      VRPEFATCOC NUMBER,
      VRPEFATCOR NUMBER,
      HRTEMPPREP VARCHAR2(5),
      CDAPRERECE VARCHAR2(03));

   TYPE PRODPRAT_PME_CURTYPE IS REF CURSOR RETURN PRODPRAT_PME_RECTYPE;

   /* CONSUMO POR SERVIO */
   TYPE CONSSERVPME_RECTYPE IS RECORD (
      CDFILCENTPME CONSSERVPME.CDFILCENTPME%TYPE,
      CDSERVFILI   CONSSERVPME.CDSERVFILI%TYPE,
      CDFILIAL     CONSSERVPME.CDFILIAL%TYPE,
      DTCONSERVPME CONSSERVPME.DTCONSERVPME%TYPE,
      CDPRODUTO    CONSSERVPME.CDPRODUTO%TYPE,
      QTCONSERVPME CONSSERVPME.QTCONSERVPME%TYPE,
      IDQTDECONPME CONSSERVPME.IDQTDECONPME%TYPE);

   TYPE CONSSERVPME_CURTYPE IS REF CURSOR RETURN CONSSERVPME_RECTYPE;

   /* CURSOR PARA ARREDONDAMENTO */
   TYPE ARREDOND_PME_RECTYPE IS RECORD (
      NRREQUCONS   VARCHAR2(10),
      CDFILIAL     FILIAL.CDFILIAL%TYPE,
      CDSERVFILI   SERVICO.CDSERVFILI%TYPE,
      DTDATA       DATE,
      IDTIPOCONS   VARCHAR2(01),
      CDFILAUXPRAT PRATO.CDFILAUXPRAT%TYPE,
      CDPRATO      PRATO.CDPRATO%TYPE,
      CDPRODUTO    PRODUTO.CDPRODUTO%TYPE,
      DTLIMITE     DATE,
      HRLIMITE     VARCHAR2(05),
      CDTIPOPRAT   TIPOPRAT.CDTIPOPRAT%TYPE,
      CDCLIENTE    CARDACLI.CDCLIENTE%TYPE,
      CDDESTFILI   CARDACLI.CDDESTFILI%TYPE,
      VRARREDREQ   PRODUTO.VRARREDREQ%TYPE,
      VRARREDCMP   PRODUTO.VRARREDCMP%TYPE,
      QTCOMENS     NUMBER,
      QTCOMENST1   NUMBER,
      QTCOMENST2   NUMBER,
      QTCOMENST3   NUMBER,
      QTCOMENST4   NUMBER);

   TYPE ARREDOND_PME_CURTYPE IS REF CURSOR RETURN ARREDOND_PME_RECTYPE;

   PROCEDURE ATUALIZA_CONSPLAN_PME(P_NRCONSPLAN   IN CONSPLAN.NRCONSPLAN%TYPE,
                                   P_CDFILCENTPME IN CONSPLAN.CDFILCENTPME%TYPE,
                                   P_CDFILIAL     IN CONSPLAN.CDFILICPLA%TYPE,
                                   P_CDTIPOCARD   IN CONSPLAN.CDTPCARDPME%TYPE,
                                   P_CDSERVFILI   IN CONSPLAN.CDSERVCPLA%TYPE,
                                   P_IDCONSPLAN   IN CONSPLAN.IDCONSPLAN%TYPE,
                                   P_CDFAPRATCPLA IN CONSPLAN.CDFAPRATCPLA%TYPE,
                                   P_CDPRATCONSPL IN CONSPLAN.CDPRATCONSPL%TYPE,
                                   P_CDAPRECONSPL IN CONSPLAN.CDAPRECONSPL%TYPE,
                                   P_CDSETOCONSPL IN CONSPLAN.CDSETOCONSPL%TYPE,
                                   P_CDPRODCPLA   IN CONSPLAN.CDPRODCPLA%TYPE,
                                   P_DTLIMITECPLA IN CONSPLAN.DTLIMITECPLA%TYPE,
                                   P_HRLIMITECPLA IN CONSPLAN.HRLIMITECPLA%TYPE,
                                   P_CDTPPRATCPLA IN CONSPLAN.CDTPPRATCPLA%TYPE,
                                   P_QTCONSPLAN   IN CONSPLAN.QTCONSPLAN%TYPE,
                                   P_VRPECONSPLAN IN CONSPLAN.VRPECONSPLAN%TYPE,
                                   P_QTCOMESTCPLA IN CONSPLAN.QTCOMESTCPLA%TYPE,
                                   P_AJUSHRLIMI   IN VARCHAR2,
                                   P_DTDATA       IN DATE);

   PROCEDURE OPEN_PRODPRAT_CURSOR_PME(C_PRODPRAT  IN OUT PRODPRAT_PME_CURTYPE,
                                   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
                                   P_CDSERVFILI   IN SERVICO.CDSERVFILI%TYPE,
                                   P_CDFILAUXPRAT IN PRATO.CDFILAUXPRAT%TYPE,
                                   P_CDPRATO      IN PRATO.CDPRATO%TYPE,
                                   P_QTPRATO      IN NUMBER,
                                   P_CDPRODUTOINI IN VARCHAR2,
                                   P_CDPRODUTOFIN IN VARCHAR2,
                                   P_IDUTILFATCOR IN PARAMPLANEJA.IDUTILFATCOR%TYPE,
                                   P_IDUTILFATCOC IN PARAMPLANEJA.IDUTILFATCOC%TYPE,
                                   P_IDTIPCALCFAT IN PARAMPLANEJA.IDTIPCALCFAT%TYPE,
                                   P_CDFILCENTPME IN FILIAL.CDFILCENTPME%TYPE,
                                   P_CDTIPOCARD   IN TIPOCARD.CDTIPOCARD%TYPE);

   PROCEDURE OPEN_CONSSERVPME_CURSOR (C_CONSSERVPME  IN OUT CONSSERVPME_CURTYPE,
                                      P_CDFILCENTPME IN CONSSERVPME.CDFILCENTPME%TYPE,
                                      P_CDSERVFILI   IN CONSSERVPME.CDSERVFILI%TYPE,
                                      P_CDFILIAL     IN CONSSERVPME.CDFILIAL%TYPE,
                                      P_DTCONSERVPME IN CONSSERVPME.DTCONSERVPME%TYPE,
                                      P_FERIADO      IN NUMBER,
                                      P_CDPRODUTOINI IN VARCHAR2,
                                      P_CDPRODUTOFIN IN VARCHAR2);

   PROCEDURE OPEN_ARREDOND_CURSOR_PME (C_ARREDOND   IN OUT ARREDOND_PME_CURTYPE,
                                       P_TIPOCURS   IN VARCHAR2,
                                       P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
                                       P_CDSERVICOS IN VARCHAR2,
                                       P_DTINICIAL  IN DATE,
                                       P_DTFINAL    IN DATE,
                                       P_NRREQUCONS IN VARCHAR2,
                                       P_NRCONSPLAN IN VARCHAR2);

   PROCEDURE OPEN_CONSPLAN_CURSOR (C_CONSPLAN     IN OUT CONSPLAN_PME_CURTYPE,
                                   P_CDFILCENTPME IN FILIAL.CDFILCENTPME%TYPE,
                                   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
                                   P_DTINICIAL    IN DATE,
                                   P_DTFINAL      IN DATE,
                                   P_SERVICOS     IN VARCHAR2,
                                   P_IDTIPOCONS   IN VARCHAR2,
                                   P_NRCONSPLAN   IN VARCHAR2);

END UTIL_CONSPLAN_PME;
/

CREATE OR REPLACE
PACKAGE BODY UTIL_CONSPLAN_PME AS

   /* - Atualiza a tabela PREVRETI verificando se o registro j existe ------ */

   /* - Atualiza a tabela CONSPLAN verificando se o registro j existe ------ */

   PROCEDURE ATUALIZA_CONSPLAN_PME(P_NRCONSPLAN   IN CONSPLAN.NRCONSPLAN%TYPE,
                                   P_CDFILCENTPME IN CONSPLAN.CDFILCENTPME%TYPE,
                                   P_CDFILIAL     IN CONSPLAN.CDFILICPLA%TYPE,
                                   P_CDTIPOCARD   IN CONSPLAN.CDTPCARDPME%TYPE,
                                   P_CDSERVFILI   IN CONSPLAN.CDSERVCPLA%TYPE,
                                   P_IDCONSPLAN   IN CONSPLAN.IDCONSPLAN%TYPE,
                                   P_CDFAPRATCPLA IN CONSPLAN.CDFAPRATCPLA%TYPE,
                                   P_CDPRATCONSPL IN CONSPLAN.CDPRATCONSPL%TYPE,
                                   P_CDAPRECONSPL IN CONSPLAN.CDAPRECONSPL%TYPE,
                                   P_CDSETOCONSPL IN CONSPLAN.CDSETOCONSPL%TYPE,
                                   P_CDPRODCPLA   IN CONSPLAN.CDPRODCPLA%TYPE,
                                   P_DTLIMITECPLA IN CONSPLAN.DTLIMITECPLA%TYPE,
                                   P_HRLIMITECPLA IN CONSPLAN.HRLIMITECPLA%TYPE,
                                   P_CDTPPRATCPLA IN CONSPLAN.CDTPPRATCPLA%TYPE,
                                   P_QTCONSPLAN   IN CONSPLAN.QTCONSPLAN%TYPE,
                                   P_VRPECONSPLAN IN CONSPLAN.VRPECONSPLAN%TYPE,
                                   P_QTCOMESTCPLA IN CONSPLAN.QTCOMESTCPLA%TYPE,
                                   P_AJUSHRLIMI   IN VARCHAR2,
                                   P_DTDATA       IN DATE) IS
      V_DTLIMITEPR   DATE;
      V_HRLIMITEPR   VARCHAR2(4);
      V_QTCOMESTCPLA CONSPLAN.QTCOMESTCPLA%TYPE;
      V_QTCONSPLAN   CONSPLAN.QTCONSPLAN%TYPE;
      V_COUNT        NUMBER;
   BEGIN
      V_QTCOMESTCPLA := P_QTCOMESTCPLA;
      IF V_QTCOMESTCPLA = 0 THEN
         V_QTCOMESTCPLA := 1;
      END IF;



      SELECT COUNT(NRCONSPLAN)
        INTO V_COUNT
        FROM CONSPLAN
      WHERE
         (NRCONSPLAN   = P_NRCONSPLAN  ) AND
         (CDFILCENTPME = P_CDFILCENTPME) AND
         (CDFILICPLA   = P_CDFILIAL    ) AND
         (CDSERVCPLA   = P_CDSERVFILI  ) AND
         (DTCONSPLAN   = P_DTDATA      ) AND
         (IDCONSPLAN   = P_IDCONSPLAN  ) AND
         (CDFAPRATCPLA = P_CDFAPRATCPLA) AND
         (CDPRATCONSPL = P_CDPRATCONSPL) AND
         (CDTPPRATCPLA = P_CDTPPRATCPLA) AND
         (CDPRODCPLA   = P_CDPRODCPLA  ) AND
         (CDTPCARDPME  = P_CDTIPOCARD  );
    
      IF (V_COUNT > 0) THEN
         UPDATE
            CONSPLAN
         SET
            QTCONSPLAN = QTCONSPLAN + P_QTCONSPLAN
         WHERE
            (NRCONSPLAN   = P_NRCONSPLAN  ) AND
            (CDFILCENTPME = P_CDFILCENTPME) AND
            (CDFILICPLA   = P_CDFILIAL    ) AND
            (CDSERVCPLA   = P_CDSERVFILI  ) AND
            (DTCONSPLAN   = P_DTDATA      ) AND
            (IDCONSPLAN   = P_IDCONSPLAN  ) AND
            (CDFAPRATCPLA = P_CDFAPRATCPLA) AND
            (CDPRATCONSPL = P_CDPRATCONSPL) AND
            (CDTPPRATCPLA = P_CDTPPRATCPLA) AND
            (CDPRODCPLA   = P_CDPRODCPLA  ) AND
            (CDTPCARDPME  = P_CDTIPOCARD  );
            COMMIT;
      ELSE

         INSERT INTO CONSPLAN
            (NRCONSPLAN,
             CDFILCENTPME,
             CDFILICPLA,
             CDTPCARDPME,
             CDSERVCPLA,
             DTCONSPLAN,
             IDCONSPLAN,
             CDFAPRATCPLA,
             CDPRATCONSPL,
             CDAPRECONSPL,
             CDSETOCONSPL,
             CDPRODCPLA,
             DTLIMITECPLA,
             HRLIMITECPLA,
             CDTPPRATCPLA,
             QTCONSPLAN,
             VRPECONSPLAN,
             QTCOMESTCPLA,
             CDCLIECPLA,
             CDDESTFICPLA)
         VALUES
            (P_NRCONSPLAN,
             P_CDFILCENTPME,
             P_CDFILIAL,
             P_CDTIPOCARD,
             P_CDSERVFILI,
             P_DTDATA,
             P_IDCONSPLAN,
             P_CDFAPRATCPLA,
             P_CDPRATCONSPL,
             P_CDAPRECONSPL,
             P_CDSETOCONSPL,
             P_CDPRODCPLA,
             TO_DATE(TO_CHAR(P_DTDATA, 'DD/MM/YYYY'), 'DD/MM/YYYY'),
             TO_CHAR(P_DTDATA, 'HH24MI'),
             P_CDTPPRATCPLA,
             P_QTCONSPLAN,
             P_VRPECONSPLAN,
             V_QTCOMESTCPLA,
             'xxx',
             'xxx');
             COMMIT;
       
      END IF;
   END; /* ATUALIZA_CONSPLAN */


   /* - Abre o cursor de acordo com o parmetro ----------------------------- */
   /* 1. Cursor a ser aberto                                                  */
   /* 2. Indicador do tipo de consumo 'Fixo' ou 'Percapita' ou 'Cardpio'     */


   PROCEDURE OPEN_PRODPRAT_CURSOR_PME(C_PRODPRAT     IN OUT PRODPRAT_PME_CURTYPE,
                                      P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
                                      P_CDSERVFILI   IN SERVICO.CDSERVFILI%TYPE,
                                      P_CDFILAUXPRAT IN PRATO.CDFILAUXPRAT%TYPE,
                                      P_CDPRATO      IN PRATO.CDPRATO%TYPE,
                                      P_QTPRATO      IN NUMBER,
                                      P_CDPRODUTOINI IN VARCHAR2,
                                      P_CDPRODUTOFIN IN VARCHAR2,
                                      P_IDUTILFATCOR IN PARAMPLANEJA.IDUTILFATCOR%TYPE,
                                      P_IDUTILFATCOC IN PARAMPLANEJA.IDUTILFATCOC%TYPE,
                                      P_IDTIPCALCFAT IN PARAMPLANEJA.IDTIPCALCFAT%TYPE,
                                      P_CDFILCENTPME IN FILIAL.CDFILCENTPME%TYPE,
                                      P_CDTIPOCARD   IN TIPOCARD.CDTIPOCARD%TYPE) IS
   BEGIN
      OPEN C_PRODPRAT FOR
         SELECT
            RECESERV.CDPRODUTO,
            RECESERV.QTBRUTASE AS QTPRODUTO,
            RECESERV.SGUNIDADE,
            RECESERV.VRPEFATCOCSE AS VRPEFATCOC,
            RECESERV.VRPEFATCORSE AS VRPEFATCOR,
            RECESERV.HRTEMPPREPSE AS HRTEMPPREP,
            RECESERV.CDAPRERECE
         FROM
            PRODUTO, RECESERV
         WHERE
            (RECESERV.CDFILAUXPRAT = P_CDFILAUXPRAT)    AND
            (RECESERV.CDPRATO      = P_CDPRATO)         AND
            (RECESERV.CDFILIAL     = P_CDFILIAL)        AND
            (RECESERV.CDSERVFILI   = P_CDSERVFILI)      AND
            (RECESERV.CDPRODUTO    = PRODUTO.CDPRODUTO) AND
            (PRODUTO.CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN)

         UNION ALL

         SELECT
            RECEFILI.CDPRODUTO,
            RECEFILI.QTBRUTALO AS QTPRODUTO,
            RECEFILI.SGUNIDADE,
            RECEFILI.VRPEFATCOCLO AS VRPEFATCOC,
            RECEFILI.VRPEFATCORLO AS VRPEFATCOR,
            RECEFILI.HRTEMPPREPLO AS HRTEMPPREP,
            RECEFILI.CDAPRERECE
         FROM
            PRODUTO, RECEFILI
         WHERE
            (RECEFILI.CDFILAUXPRAT = P_CDFILAUXPRAT)    AND
            (RECEFILI.CDPRATO      = P_CDPRATO)         AND
            (RECEFILI.CDFILIAL     = P_CDFILIAL)        AND
            (RECEFILI.CDPRODUTO    = PRODUTO.CDPRODUTO) AND
            (PRODUTO.CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN) AND
             NOT EXISTS (SELECT
                            CDPRATO
                         FROM
                            RECESERV
                         WHERE
                            (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                            (CDPRATO      = P_CDPRATO)      AND
                            (CDFILIAL     = P_CDFILIAL)     AND
                            (CDSERVFILI   = P_CDSERVFILI)
                         )
                         
         UNION ALL

         SELECT
            RECETPCARD.CDPRODUTO,
            RECETPCARD.QTBRUTAPRTP AS QTPRODUTO,
            RECETPCARD.SGUNIDADE,
            RECETPCARD.VRPEFATCOCPRTP AS VRPEFATCOC,
            RECETPCARD.VRPEFATCORPRTP AS VRPEFATCOR,
            RECETPCARD.HRTEMPPREPPRTP AS HRTEMPPREP,
            RECETPCARD.CDAPRERECE
         FROM
            PRODUTO, RECETPCARD
         WHERE
            (RECETPCARD.CDFILAUXPRAT = P_CDFILAUXPRAT)    AND
            (RECETPCARD.CDPRATO      = P_CDPRATO)         AND
            (RECETPCARD.CDFILCENTPME = P_CDFILCENTPME)    AND
            (RECETPCARD.CDTIPOCARD   = P_CDTIPOCARD)      AND
            (RECETPCARD.CDPRODUTO    = PRODUTO.CDPRODUTO) AND
            (PRODUTO.CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN) AND
             NOT EXISTS (SELECT
                            CDPRATO
                         FROM
                            RECEFILI
                         WHERE
                            (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                            (CDPRATO      = P_CDPRATO)      AND
                            (CDFILIAL     = P_CDFILIAL)
                         ) AND
             NOT EXISTS (SELECT
                            CDPRATO
                         FROM
                            RECESERV
                         WHERE
                            (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                            (CDPRATO      = P_CDPRATO)      AND
                            (CDFILIAL     = P_CDFILIAL)     AND
                            (CDSERVFILI   = P_CDSERVFILI))
         
         UNION ALL
         
         SELECT
            RECEPADR.CDPRODUTO,
            RECEPADR.QTBRUTAPR AS QTPRODUTO,
            RECEPADR.SGUNIDADE,
            RECEPADR.VRPEFATCOCPR AS VRPEFATCOC,
            RECEPADR.VRPEFATCORPR AS VRPEFATCOR,
            RECEPADR.HRTEMPPREPPR AS HRTEMPPREP,
            RECEPADR.CDAPRERECE
         FROM
            PRODUTO, RECEPADR
         WHERE
            (RECEPADR.CDFILAUXPRAT = P_CDFILAUXPRAT)    AND
            (RECEPADR.CDPRATO      = P_CDPRATO)         AND
            (RECEPADR.CDPRODUTO    = PRODUTO.CDPRODUTO) AND
            (PRODUTO.CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN) AND
             NOT EXISTS (SELECT
                            CDPRATO
                         FROM
                            RECETPCARD
                         WHERE
                            (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                            (CDPRATO      = P_CDPRATO)      AND
                            (CDFILCENTPME = P_CDFILCENTPME) AND
                            (CDTIPOCARD   = P_CDTIPOCARD)
                         ) AND
             NOT EXISTS (SELECT
                            CDPRATO
                         FROM
                            RECEFILI
                         WHERE
                            (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                            (CDPRATO      = P_CDPRATO)      AND
                            (CDFILIAL     = P_CDFILIAL)
                         ) AND
             NOT EXISTS (SELECT
                            CDPRATO
                         FROM
                            RECESERV
                         WHERE
                            (CDFILAUXPRAT = P_CDFILAUXPRAT) AND
                            (CDPRATO      = P_CDPRATO)      AND
                            (CDFILIAL     = P_CDFILIAL)     AND
                            (CDSERVFILI   = P_CDSERVFILI));
   END; /* OPEN_PRODPRAT_CURSOR */



   PROCEDURE OPEN_CONSSERVPME_CURSOR (C_CONSSERVPME  IN OUT CONSSERVPME_CURTYPE,
                                      P_CDFILCENTPME IN CONSSERVPME.CDFILCENTPME%TYPE,
                                      P_CDSERVFILI   IN CONSSERVPME.CDSERVFILI%TYPE,
                                      P_CDFILIAL     IN CONSSERVPME.CDFILIAL%TYPE,
                                      P_DTCONSERVPME IN CONSSERVPME.DTCONSERVPME%TYPE,
                                      P_FERIADO      IN NUMBER,
                                      P_CDPRODUTOINI IN VARCHAR2,
                                      P_CDPRODUTOFIN IN VARCHAR2) IS
      /* variaveis BIND */
      w_9 CHAR(01) := '9';
      w_F CHAR(01) := 'F';
      w_A CHAR(01) := 'A';
      w_P CHAR(01) := 'P';
      w_8 CHAR(01) := '8';
      w_ZERO FLOAT := 0;
   BEGIN

      OPEN C_CONSSERVPME FOR
         SELECT
            CS.CDFILCENTPME,
            CS.CDSERVFILI,
            CS.CDFILIAL,
            CS.DTCONSERVPME,
            CS.CDPRODUTO,
            CS.QTCONSERVPME,
            CS.IDQTDECONPME
         FROM
            CONSSERVPME CS, PRODUTO, SERVTIPOCARD ST, PARAMPLANEJA PA, FILITIPOCARD TC
         WHERE
            (CS.CDFILCENTPME = P_CDFILCENTPME)                    AND
            (CS.CDSERVFILI   = P_CDSERVFILI)                      AND
            (CS.CDFILIAL     = P_CDFILIAL)                        AND
            (CS.DTCONSERVPME = P_DTCONSERVPME)                    AND
            (CS.IDTIPOCONPME = w_9)                               AND
            (CS.IDQTDECONPME = w_F)                               AND
            (CS.CDPRODUTO    = PRODUTO.CDPRODUTO)                 AND
            (CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN) AND
            (ST.CDFILCENTPME = CS.CDFILCENTPME)                   AND
            (ST.CDSERVFILI   = CS.CDSERVFILI)                     AND
            (ST.CDTIPOCARD   = PA.CDTCACONSFIX)                   AND
            (PA.CDFILIAL     = ST.CDFILCENTPME)                   AND
            (TC.CDFILCENTPME = ST.CDFILCENTPME)                   AND
            (TC.CDTIPOCARD = ST.CDTIPOCARD)                       AND
            (TC.CDFILIAL = CS.CDFILIAL)                           AND
            (TC.IDTCARATFILI = 'S')                               AND
            NOT EXISTS (SELECT
                           CDFILIAL
                        FROM
                           DIASEMCONSPME
                        WHERE
                           CDFILCENTPME = P_CDFILCENTPME AND
                           CDSERVFILI   = P_CDSERVFILI   AND
                           CDFILIAL     = P_CDFILIAL     AND
                           DTSEMCONSPME = P_DTCONSERVPME AND
                           IDTPCONSPME IN (w_F, w_A))

         UNION ALL

         SELECT
            CS.CDFILCENTPME,
            CS.CDSERVFILI,
            CS.CDFILIAL,
            CS.DTCONSERVPME,
            CS.CDPRODUTO,
            CS.QTCONSERVPME,
            CS.IDQTDECONPME
         FROM
            CONSSERVPME CS, PRODUTO, SERVTIPOCARD ST, PARAMPLANEJA PA, FILITIPOCARD TC
         WHERE
            (CS.CDFILCENTPME = P_CDFILCENTPME)                    AND
            (CS.CDSERVFILI   = P_CDSERVFILI)                      AND
            (CS.CDFILIAL     = P_CDFILIAL)                        AND
            (CS.DTCONSERVPME = P_DTCONSERVPME)                    AND
            (CS.IDTIPOCONPME = w_9)                               AND
            (CS.IDQTDECONPME = w_P)                               AND
            (CS.CDPRODUTO    = PRODUTO.CDPRODUTO)                 AND
            (CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN) AND
            (ST.CDFILCENTPME = CS.CDFILCENTPME)                   AND
            (ST.CDSERVFILI   = CS.CDSERVFILI)                     AND
            (ST.CDTIPOCARD   = PA.CDTCACONSPER)                   AND
            (PA.CDFILIAL     = ST.CDFILCENTPME)                   AND
            (TC.CDFILCENTPME = ST.CDFILCENTPME)                   AND
            (TC.CDTIPOCARD = ST.CDTIPOCARD)                       AND
            (TC.CDFILIAL = CS.CDFILIAL)                           AND
            (TC.IDTCARATFILI = 'S')                               AND 
            NOT EXISTS (SELECT
                           CDFILIAL
                        FROM
                           DIASEMCONSPME
                        WHERE
                           CDFILCENTPME = P_CDFILCENTPME AND
                           CDSERVFILI   = P_CDSERVFILI   AND
                           CDFILIAL     = P_CDFILIAL     AND
                           DTSEMCONSPME = P_DTCONSERVPME AND
                           IDTPCONSPME IN (w_P, w_A))

         UNION ALL

         SELECT
            CS.CDFILCENTPME,
            CS.CDSERVFILI,
            CS.CDFILIAL,
            CS.DTCONSERVPME,
            CS.CDPRODUTO,
            CS.QTCONSERVPME,
            CS.IDQTDECONPME
         FROM
            CONSSERVPME CS, PRODUTO, SERVTIPOCARD ST, PARAMPLANEJA PA, FILITIPOCARD TC
         WHERE
            (CS.CDFILCENTPME = P_CDFILCENTPME)                    AND
            (CS.CDSERVFILI   = P_CDSERVFILI)                      AND
            (CS.CDFILIAL     = P_CDFILIAL)                        AND
            (CS.CDPRODUTO    = PRODUTO.CDPRODUTO)                 AND
            (CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN) AND
            (ST.CDFILCENTPME = CS.CDFILCENTPME)                   AND
            (ST.CDSERVFILI   = CS.CDSERVFILI)                     AND
            (ST.CDTIPOCARD   = PA.CDTCACONSFIX)                   AND
            (PA.CDFILIAL     = ST.CDFILCENTPME)                   AND
            (TC.CDFILCENTPME = ST.CDFILCENTPME)                   AND
            (TC.CDTIPOCARD = ST.CDTIPOCARD)                       AND
            (TC.CDFILIAL = CS.CDFILIAL)                           AND
            (TC.IDTCARATFILI = 'S')                               AND 
            DTCONSERVPME IN (SELECT MAX(DTCONSERVPME)
                           FROM CONSSERVPME
                           WHERE CDFILCENTPME = P_CDFILCENTPME  AND
                                 CDSERVFILI   = P_CDSERVFILI    AND
                                 CDFILIAL     = P_CDFILIAL      AND
                                 DTCONSERVPME <= P_DTCONSERVPME AND
                                 IDTIPOCONPME <> w_9)           AND
            ((IDTIPOCONPME = TO_CHAR(P_DTCONSERVPME, 'D') AND P_FERIADO = w_ZERO) OR
             (IDTIPOCONPME = w_8 AND P_FERIADO <> w_ZERO)) AND
            IDQTDECONPME   = w_F                      AND
            NOT EXISTS (SELECT
                           CDFILIAL
                        FROM
                           DIASEMCONSPME
                        WHERE
                           CDFILCENTPME = P_CDFILCENTPME AND
                           CDSERVFILI   = P_CDSERVFILI   AND
                           CDFILIAL     = P_CDFILIAL     AND
                           DTSEMCONSPME = P_DTCONSERVPME AND
                           IDTPCONSPME IN (w_F, w_A))    AND
           NOT EXISTS (SELECT
                          CDFILIAL
                       FROM
                          CONSSERVPME
                       WHERE
                          CDFILCENTPME = P_CDFILCENTPME AND
                          CDSERVFILI   = P_CDSERVFILI   AND
                          CDFILIAL     = P_CDFILIAL     AND
                          DTCONSERVPME = P_DTCONSERVPME AND
                          IDTIPOCONPME = w_9            AND
                          IDQTDECONPME = w_F)

         UNION ALL

         SELECT
            CS.CDFILCENTPME,
            CS.CDSERVFILI,
            CS.CDFILIAL,
            CS.DTCONSERVPME,
            CS.CDPRODUTO,
            CS.QTCONSERVPME,
            CS.IDQTDECONPME
         FROM
            CONSSERVPME CS, PRODUTO, SERVTIPOCARD ST, PARAMPLANEJA PA, FILITIPOCARD TC
         WHERE
            (CS.CDFILCENTPME = P_CDFILCENTPME)                    AND
            (CS.CDSERVFILI   = P_CDSERVFILI)                      AND
            (CS.CDFILIAL     = P_CDFILIAL)                        AND
            (CS.CDPRODUTO    = PRODUTO.CDPRODUTO)                 AND
            (CDARVPROD BETWEEN P_CDPRODUTOINI AND P_CDPRODUTOFIN) AND
            (ST.CDFILCENTPME = CS.CDFILCENTPME)                   AND
            (ST.CDSERVFILI   = CS.CDSERVFILI)                     AND
            (ST.CDTIPOCARD   = PA.CDTCACONSPER)                   AND
            (PA.CDFILIAL     = ST.CDFILCENTPME)                   AND
            (TC.CDFILCENTPME = ST.CDFILCENTPME)                   AND
            (TC.CDTIPOCARD = ST.CDTIPOCARD)                       AND
            (TC.CDFILIAL = CS.CDFILIAL)                           AND
            (TC.IDTCARATFILI = 'S')                               AND
            DTCONSERVPME IN (SELECT MAX(DTCONSERVPME)
                             FROM CONSSERVPME
                             WHERE CDFILCENTPME  = P_CDFILCENTPME AND
                                   CDSERVFILI    = P_CDSERVFILI   AND
                                   CDFILIAL      = P_CDFILIAL     AND
                                   DTCONSERVPME <= P_DTCONSERVPME AND
                                   IDTIPOCONPME <> w_9)           AND
            ((IDTIPOCONPME = TO_CHAR(P_DTCONSERVPME, 'D') AND P_FERIADO = w_ZERO) OR
             (IDTIPOCONPME = w_8 AND P_FERIADO <> w_ZERO)) AND
            IDQTDECONPME   = w_P                      AND
            NOT EXISTS (SELECT
                           CDFILIAL
                        FROM
                           DIASEMCONSPME
                        WHERE
                           CDFILCENTPME  = P_CDFILCENTPME AND
                           CDSERVFILI    = P_CDSERVFILI   AND
                           CDFILIAL      = P_CDFILIAL     AND
                           DTSEMCONSPME = P_DTCONSERVPME AND
                           IDTPCONSPME IN (w_P, w_A))     AND
            NOT EXISTS (SELECT
                           CDFILIAL
                        FROM
                           CONSSERVPME
                        WHERE
                           CDFILCENTPME = P_CDFILCENTPME AND
                           CDSERVFILI   = P_CDSERVFILI   AND
                           CDFILIAL     = P_CDFILIAL     AND
                           DTCONSERVPME = P_DTCONSERVPME AND
                           IDTIPOCONPME = w_9            AND
                           IDQTDECONPME = w_P)
            ORDER BY 6, 4;
   END; /* OPEN_CONSSERVPME_CURSOR */


   PROCEDURE OPEN_ARREDOND_CURSOR_PME (C_ARREDOND    IN OUT ARREDOND_PME_CURTYPE,
                                       P_TIPOCURS    IN VARCHAR2,
                                       P_CDFILIAL    IN FILIAL.CDFILIAL%TYPE,
                                       P_CDSERVICOS  IN VARCHAR2,
                                       P_DTINICIAL   IN DATE,
                                       P_DTFINAL     IN DATE,
                                       P_NRREQUCONS  IN VARCHAR2,
                                       P_NRCONSPLAN  IN VARCHAR2) IS
   BEGIN
      OPEN C_ARREDOND FOR
         SELECT
            CP.NRCONSPLAN, CP.CDFILICPLA, CP.CDSERVCPLA, CP.DTCONSPLAN, CP.IDCONSPLAN,
            CP.CDFAPRATCPLA, CP.CDPRATCONSPL, CP.CDPRODCPLA,
            CP.DTLIMITECPLA, CP.HRLIMITECPLA,
            CP.CDTPPRATCPLA, CP.CDCLIECPLA, CP.CDDESTFICPLA, PR.VRARREDREQ, PR.VRARREDCMP,
            SUM(CP.QTCONSPLAN) QTCONSPLAN, SUM(CP.QTCONSPLANT1) QTCONSPLANT1,
            SUM(CP.QTCONSPLANT2) QTCONSPLANT2, SUM(CP.QTCONSPLANT3) QTCONSPLANT3, SUM(CP.QTCONSPLANT4) QTCONSPLANT4
         FROM
            PRODUTO PR,
            CONSPLAN CP
         WHERE
            (CP.NRCONSPLAN = P_NRCONSPLAN)    AND
            (CP.CDFILCENTPME = P_CDFILIAL)      AND
            (PR.CDPRODUTO  = CP.CDPRODCPLA)   AND
            (CP.DTCONSPLAN BETWEEN P_DTINICIAL AND P_DTFINAL)
         GROUP BY
            CP.NRCONSPLAN, CP.CDFILICPLA, CP.CDSERVCPLA, CP.DTCONSPLAN,
            CP.IDCONSPLAN, CP.CDCLIECPLA, CP.CDDESTFICPLA, CP.CDFAPRATCPLA,
            CP.CDPRATCONSPL, CP.CDPRODCPLA, CP.DTLIMITECPLA, CP.HRLIMITECPLA,
            CP.CDTPPRATCPLA, PR.VRARREDREQ, PR.VRARREDCMP;

   END; /* OPEN_ARREDOND_PME_CURSOR */


   PROCEDURE OPEN_CONSPLAN_CURSOR (C_CONSPLAN     IN OUT CONSPLAN_PME_CURTYPE,
                                   P_CDFILCENTPME IN FILIAL.CDFILCENTPME%TYPE,
                                   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
                                   P_DTINICIAL    IN DATE,
                                   P_DTFINAL      IN DATE,
                                   P_SERVICOS     IN VARCHAR2,
                                   P_IDTIPOCONS   IN VARCHAR2,
                                   P_NRCONSPLAN   IN VARCHAR2) IS
   BEGIN
      IF (P_IDTIPOCONS = 'C') THEN
         /* -- Consumo do CARDAPIO -- */
         OPEN C_CONSPLAN FOR
            SELECT
               CA.DTCARDIAPME,
               CA.CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0) AS HRINICATEN,
               CA.NRCARDPME,
               'XXX' CDCLIENTE,
               'XXX' CDDESTFILI,
               CA.QTCOMESTCPME,
               SE.CDFILIAL
            FROM
               CARDIAPME CA,
               SERVICO   SE
            WHERE
               (CA.CDFILCENTPME = P_CDFILCENTPME)                                                AND
               (INSTR(NVL(P_CDFILIAL, SE.CDFILIAL), SE.CDFILIAL) > 0)                            AND
               (INSTR(NVL(P_SERVICOS, SE.CDSERVFILI), SE.CDSERVFILI) <> 0 OR (P_SERVICOS = 'T')) AND
               (CA.CDFILIAL     = SE.CDFILIAL   )                                                AND
               (CA.CDSERVFILI   = SE.CDSERVFILI )                                                AND
               (CA.DTCARDIAPME  BETWEEN P_DTINICIAL AND P_DTFINAL)                               AND
               NOT EXISTS (SELECT * FROM CARDACLI
                           WHERE CDFILIAL   = CA.CDFILIAL AND
                                 NRCARDAPIO = CA.NRCARDPME)

            UNION

            SELECT
               CA.DTCARDIAPME,
               CA.CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0) AS HRINICATEN,
               CA.NRCARDPME,
               CC.CDCLIENTE,
               CC.CDDESTFILI,
               CC.QTCOMESTICLI QTCOMESTICAR,
               SE.CDFILIAL
            FROM
               CARDACLI  CC,
               CARDIAPME CA,
               SERVICO   SE
            WHERE
               (CA.CDFILCENTPME = P_CDFILCENTPME)                                                AND
               (INSTR(NVL(P_CDFILIAL, SE.CDFILIAL), SE.CDFILIAL) > 0)                            AND
               (INSTR(NVL(P_SERVICOS, SE.CDSERVFILI), SE.CDSERVFILI) <> 0 OR (P_SERVICOS = 'T')) AND
               (CA.CDFILIAL     = SE.CDFILIAL   )                                                AND
               (CA.CDSERVFILI   = SE.CDSERVFILI )                                                AND
               (CA.DTCARDIAPME BETWEEN P_DTINICIAL AND P_DTFINAL)                                AND
               (CC.CDFILIAL     = CA.CDFILIAL   )                                                AND
               (CC.NRCARDAPIO   = CA.NRCARDPME  )
            ORDER BY
               1, 2, 3, 4, 5, 6;

      ELSIF (P_IDTIPOCONS = 'P') THEN
         /* -- Consumo por Servio PER CAPITA - proporcional aos comensais -- */
         OPEN C_CONSPLAN FOR
            SELECT
               DT.DTDATA,
               SE.CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0) AS HRINICATEN,
               'PPPPPPPPPP' NRCARDAPIO,
               'XXX' CDCLIENTE,
               'XXX' CDDESTFILI,
               SUM(CA.QTCOMESTCPME) QTCOMESTICAR,
               SE.CDFILIAL
            FROM
               DATA DT,
               SERVICO SE,
               CARDIAPME CA,
               PARAMPLANEJA PA,
               SERVTIPOCARD ST
            WHERE
               (CA.CDFILCENTPME = P_CDFILCENTPME )                              AND
               (INSTR(NVL(P_CDFILIAL, SE.CDFILIAL), SE.CDFILIAL) > 0)           AND
               (INSTR(NVL(P_SERVICOS, SE.CDSERVFILI), SE.CDSERVFILI) <> 0 OR (P_SERVICOS = 'T')) AND
               (CA.CDFILIAL     = SE.CDFILIAL    )                              AND
               (CA.CDSERVFILI   = SE.CDSERVFILI  )                              AND
               (CA.DTCARDIAPME  BETWEEN P_DTINICIAL AND P_DTFINAL)              AND
               (DT.DTDATA       = CA.DTCARDIAPME )                              AND
               (PA.CDFILIAL     = CA.CDFILCENTPME)                              AND
               (ST.CDFILCENTPME = PA.CDFILIAL)                                  AND
               (ST.CDTIPOCARD   = PA.CDTCACONSPER)                              AND
               (ST.CDSERVFILI   = SE.CDSERVFILI)                                AND
               (NOT EXISTS (SELECT * FROM CARDACLI
                            WHERE CDFILIAL   = CA.CDFILIAL AND
                                  NRCARDAPIO = CA.NRCARDPME))
            GROUP BY
               DT.DTDATA,
               SE.CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0),
               SE.CDFILIAL

            UNION ALL

            SELECT
               DT.DTDATA,
               SE.CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0) AS HRINICATEN,
               'PPPPPPPPPP' NRCARDAPIO,
               CC.CDCLIENTE,
               CC.CDDESTFILI,
               SUM(CC.QTCOMESTICLI) QTCOMESTICAR,
               SE.CDFILIAL
            FROM
               CARDACLI CC,
               DATA DT,
               SERVICO SE,
               CARDIAPME CA,
               PARAMPLANEJA PA,
               SERVTIPOCARD ST
            WHERE
               (CA.CDFILCENTPME = P_CDFILCENTPME )                             AND
               (INSTR(NVL(P_CDFILIAL, SE.CDFILIAL), SE.CDFILIAL) > 0)          AND
               (INSTR(NVL(P_SERVICOS, SE.CDSERVFILI), SE.CDSERVFILI) <> 0 OR (P_SERVICOS = 'T')) AND
               (CA.CDFILIAL     = SE.CDFILIAL    )                             AND
               (CA.CDSERVFILI   = SE.CDSERVFILI  )                             AND
               (CA.DTCARDIAPME  BETWEEN P_DTINICIAL AND P_DTFINAL)             AND
               (DT.DTDATA       = CA.DTCARDIAPME )                             AND
               (CC.CDFILIAL     = CA.CDFILIAL    )                             AND
               (CC.NRCARDAPIO   = CA.NRCARDPME   )                             AND
               (PA.CDFILIAL     = CA.CDFILCENTPME)                             AND
               (ST.CDFILCENTPME = PA.CDFILIAL)                                 AND
               (ST.CDTIPOCARD   = PA.CDTCACONSPER)                             AND
               (ST.CDSERVFILI   = SE.CDSERVFILI)
            GROUP BY
               DT.DTDATA,
               SE.CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0),
               CC.CDCLIENTE,
               CC.CDDESTFILI,
               SE.CDFILIAL

            UNION ALL

            SELECT
               DT.DTDATA,
               SE.CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0) AS HRINICATEN,
               NULL NRCARDAPIO,
               'XXX' CDCLIENTE,
               'XXX' CDDESTFILI,
               0 QTCOMESTICAR,
               SE.CDFILIAL
            FROM
               DATA DT,
               SERVICO SE,
               PARAMPLANEJA PA,
               SERVTIPOCARD ST
            WHERE
               (INSTR(NVL(P_CDFILIAL, SE.CDFILIAL), SE.CDFILIAL) > 0)        AND
               (INSTR(NVL(P_SERVICOS, SE.CDSERVFILI), SE.CDSERVFILI) <> 0 OR (P_SERVICOS = 'T')) AND
               (DT.DTDATA   BETWEEN P_DTINICIAL AND P_DTFINAL)               AND
               (PA.CDFILIAL     = P_CDFILCENTPME)                            AND
               (ST.CDFILCENTPME = PA.CDFILIAL)                               AND
               (ST.CDTIPOCARD   = PA.CDTCACONSPER)                           AND
               (ST.CDSERVFILI   = SE.CDSERVFILI)                             AND
               (NOT EXISTS (SELECT
                               CA.CDFILIAL
                            FROM
                               CARDIAPME CA
                            WHERE
                               (CA.CDFILIAL    = SE.CDFILIAL  ) AND
                               (CA.CDSERVFILI  = SE.CDSERVFILI) AND
                               (CA.DTCARDIAPME = DT.DTDATA)))
            ORDER BY 1, 2, 3, 4, 5, 6;
      ELSIF (P_IDTIPOCONS = 'F') THEN
         /* -- Consumo por Servio 'fixo' - no considera os comensais -- */
         OPEN C_CONSPLAN FOR
            SELECT
               DT.DTDATA,
               SE.CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0) AS HRINICATEN,
               NULL NRCARDAPIO,
               'XXX' CDCLIENTE,
               'XXX' CDDESTFILI,
               0 QTCOMESTICAR,
               SE.CDFILIAL
            FROM
               DATA DT,
               SERVICO SE,
               PARAMPLANEJA PA,
               SERVTIPOCARD ST
            WHERE
               (INSTR(NVL(P_CDFILIAL, SE.CDFILIAL), SE.CDFILIAL) > 0)      AND
               (INSTR(NVL(P_SERVICOS, SE.CDSERVFILI), SE.CDSERVFILI) <> 0 OR (P_SERVICOS = 'T')) AND
               (DT.DTDATA   BETWEEN P_DTINICIAL AND P_DTFINAL) AND
               (PA.CDFILIAL     = P_CDFILCENTPME) AND
               (ST.CDFILCENTPME = PA.CDFILIAL)                               AND
               (ST.CDTIPOCARD   = PA.CDTCACONSFIX)                           AND
               (ST.CDSERVFILI   = SE.CDSERVFILI)
            ORDER BY
               DTDATA,
               CDSERVFILI,
               RPAD(SE.HRINICATEN, 4, 0);

      ELSE
          /* --  P_IDTIPOCONS = PF --  */
          /* -- Consumo por Servio PER CAPITA - proporcional aos comensais -- */
          /* -- Consumo por Servio 'fixo' - no considera os comensais -- */

         OPEN C_CONSPLAN FOR
            SELECT DT.DTDATA,
                 S.CDSERVFILI,
                 RPAD(S.HRINICATEN, 4, 0) AS HRINICATEN,
                 CA.NRCARDPME AS NRCARDAPIO,
                 CA.CDCLIENTE AS CDCLIENTE,
                 CA.CDDESTFILI AS CDDESTFILI,
                 SUM(CA.QTCOMESTCPME) AS QTCOMESTICAR,
                 S.CDFILIAL
           FROM SERVTIPOCARD ST
                INNER JOIN FILITIPOCARD FT ON FT.CDFILCENTPME = ST.CDFILCENTPME AND
                                              FT.CDTIPOCARD = ST.CDTIPOCARD AND
                                              FT.IDTCARATFILI = 'S'
                INNER JOIN SERVICO S ON S.CDSERVFILI = ST.CDSERVFILI AND
                                        S.CDFILIAL = FT.CDFILIAL
                INNER JOIN PARAMPLANEJA PA ON PA.CDFILIAL = ST.CDFILCENTPME AND
                                              (ST.CDTIPOCARD = PA.CDTCACONSPER OR  ST.CDTIPOCARD = PA.CDTCACONSFIX)
                CROSS JOIN DATA DT
                LEFT JOIN 
                (SELECT CA.CDFILCENTPME, CA.NRCARDPME, CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDIAPME, 
                        NVL(CL.CDCLIENTE, 'XXX') AS CDCLIENTE, 
                        NVL(CL.CDDESTFILI, 'XXX') AS CDDESTFILI,
                        NVL(CL.QTCOMESTICLI, CA.QTCOMESTCPME) AS QTCOMESTCPME       
                   FROM CARDIAPME CA
                        LEFT JOIN CARDACLI CL ON CL.CDFILIAL = CA.CDFILIAL AND
                                                CL.NRCARDAPIO = CA.NRCARDPME
                  WHERE CA.CDFILCENTPME = P_CDFILCENTPME
                    AND CA.DTCARDIAPME BETWEEN P_DTINICIAL AND P_DTFINAL
                    AND (INSTR(NVL(P_CDFILIAL, CA.CDFILIAL), CA.CDFILIAL) > 0)          
                    AND (INSTR(NVL(P_SERVICOS, CA.CDSERVFILI), CA.CDSERVFILI) <> 0 OR (P_SERVICOS = 'T'))                  
                ) CA ON CA.CDFILIAL = S.CDFILIAL AND
                        CA.CDSERVFILI = S.CDSERVFILI AND
                        CA.DTCARDIAPME = DT.DTDATA
          WHERE (((ST.CDTIPOCARD = PA.CDTCACONSPER) AND (CA.CDFILCENTPME IS NOT NULL)) OR 
                 (ST.CDTIPOCARD = PA.CDTCACONSFIX))                 
            AND (ST.CDFILCENTPME = P_CDFILCENTPME ) 
            AND (INSTR(NVL(P_CDFILIAL, S.CDFILIAL), S.CDFILIAL) > 0)          
            AND (INSTR(NVL(P_SERVICOS, S.CDSERVFILI), S.CDSERVFILI) <> 0 OR (P_SERVICOS = 'T'))            
            AND (DT.DTDATA BETWEEN P_DTINICIAL AND P_DTFINAL)
          GROUP BY
               DT.DTDATA,
               S.CDSERVFILI,
               RPAD(S.HRINICATEN, 4, 0),
               S.CDFILIAL,
               CA.NRCARDPME,
               CA.CDCLIENTE,
               CA.CDDESTFILI
          
          ORDER BY 1, 2, 3, 4, 5, 6;

      END IF;
   END; /* OPEN_CONSPLAN_CURSOR */

END UTIL_CONSPLAN_PME;
/

-- VERSAO --
BEGIN ATUVEROBJ('BODY','5.50.xxx'); END;
/

