CREATE TABLE PARAMMERCADUM (
    NRORG             	 NUMBER 	  	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
	IDULTINTEGRAMERCADUM VARCHAR2(1)  	NOT NULL
		CONSTRAINT CKC_IDULTINTMERCADUM CHECK (IDULTINTEGRAMERCADUM IN ('S','N')),
	IDINTGPEDCOL      	 VARCHAR2(1)  	NOT NULL
		CONSTRAINT CKC_IDINTGPEDCOL CHECK (IDINTGPEDCOL IN ('S','N')),
	IDINTGAUTOFORN    	 VARCHAR2(1)  	NOT NULL
		CONSTRAINT CKC_IDINTGAUTOFORN CHECK (IDINTGAUTOFORN IN ('S','N')),
	IDTIPOAUTOFORN    	 VARCHAR2(1)  	NOT NULL
		CONSTRAINT CKC_IDTIPOAUTOFORN CHECK (IDTIPOAUTOFORN IN ('M','A', 'B')),
	IDINTGCONTPAG     	 VARCHAR2(1)   	NOT NULL
		CONSTRAINT CKC_IDINTGCONTPAG CHECK (IDINTGCONTPAG IN ('S','N')),
	IDINTGNOTIFIC     	 VARCHAR2(1)  	NOT NULL
		CONSTRAINT CKC_IDINTGNOTIFIC CHECK (IDINTGNOTIFIC IN ('S','N')),
	DSTOKENINTGECO    	 VARCHAR2(50) 	NOT NULL,
	DSWEBSERVICE  	 	 VARCHAR2(50)  	NOT NULL,
    DTINCLUSAO        	 DATE          	DEFAULT SYSDATE,
    DTULTATU          	 DATE          	DEFAULT SYSDATE,
    NRORGINCLUSAO     	 NUMBER        	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERINCLUSAO    	 VARCHAR2(12)  	DEFAULT '1',
    NRORGULTATU       	 NUMBER        	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERULTATU      	 VARCHAR2(12)  	DEFAULT '1',
	IDATIVO           	 VARCHAR2(1)   	DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_PARAMMERCADUM CHECK (IDATIVO IN ('S','N')),
		CONSTRAINT PK_PARAMMERCADUM PRIMARY KEY(NRORG)
)
/

CREATE TABLE RELACPRODOLCX 
(
    CDFILIALOL    	  VARCHAR(4)      	NOT NULL, 
    CDPRODUTOL    	  VARCHAR2(10)     	NOT NULL,
    CDPRODCAIXA   	  VARCHAR2(10)    	NOT NULL,
       CONSTRAINT PK_RELACPRODOLCX PRIMARY KEY (CDFILIALOL, CDPRODUTOL),
	NRORG             NUMBER 	    	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)   	DEFAULT 'S' 					NOT NULL
      CONSTRAINT CKC_IDATIVO_RELACPRODOLCX CHECK (IDATIVO IN ('S','N')),
    DTINCLUSAO        DATE              NULL,
    DTULTATU          DATE              NULL,
    NRORGINCLUSAO     NUMBER          	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    	DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    	DEFAULT '1'
)
/
 
CREATE INDEX OPL00004_FK ON RELACPRODOLCX (CDFILIALOL ASC)
/

ALTER TABLE RELACPRODOLCX
    ADD CONSTRAINT FKOPL00004FILIAL FOREIGN KEY  (CDFILIALOL)
       REFERENCES FILIAL (CDFILIAL)
/

CREATE INDEX OPL00005_FK ON RELACPRODOLCX (CDPRODUTOL ASC)
/

ALTER TABLE RELACPRODOLCX
    ADD CONSTRAINT FKOPL00005PRODUTO FOREIGN KEY  (CDPRODUTOL)
       REFERENCES PRODUTO (CDPRODUTO)
/

CREATE INDEX OPL00006_FK ON RELACPRODOLCX (CDPRODCAIXA ASC)
/

ALTER TABLE RELACPRODOLCX
    ADD CONSTRAINT FKOPL00006PRODUTO FOREIGN KEY  (CDPRODCAIXA)
       REFERENCES PRODUTO (CDPRODUTO)
/

ALTER TABLE TIPOOPEROPL ADD IDTPOPSACAIXA VARCHAR2(1) NULL
/

ALTER TABLE TIPOOPEROPL ADD CDTPOPSACAIXA VARCHAR2(2) NULL
/

ALTER TABLE TIPOOPEROPL ADD IDTPOPENCAIXA VARCHAR2(1) NULL
/

ALTER TABLE TIPOOPEROPL ADD CDTPOPENCAIXA VARCHAR2(2) NULL
/

CREATE INDEX OPL00007_FK ON TIPOOPEROPL ( IDTPOPSACAIXA ASC , CDTPOPSACAIXA ASC)
/

ALTER TABLE TIPOOPEROPL
    ADD CONSTRAINT FKOPL00007TIPOOPERAC FOREIGN KEY  ( IDTPOPSACAIXA, CDTPOPSACAIXA)
       REFERENCES TIPOOPERAC (IDENTRSAIDOP, CDTIPOOPER)
/

CREATE INDEX OPL00008_FK ON TIPOOPEROPL ( IDTPOPENCAIXA ASC, CDTPOPENCAIXA ASC)
/

ALTER TABLE TIPOOPEROPL
    ADD CONSTRAINT FKOPL00008TIPOOPERAC FOREIGN KEY  ( IDTPOPENCAIXA, CDTPOPENCAIXA)
       REFERENCES TIPOOPERAC (IDENTRSAIDOP, CDTIPOOPER)

/

ALTER TABLE NOTAFISCAL ADD DSNOTAORIGOLCX VARCHAR2(14) NULL
/

CREATE INDEX NOTAFISCAL_0001 on NOTAFISCAL (DSNOTAORIGOLCX  ASC)
/

CREATE TABLE OM_PRODUTO_ORG_COLETOR (
    ID               NUMBER        NOT NULL,
    NRPRODUTO_ORG_ID NUMBER        NOT NULL,
    DSSTRINGCONEXAO  VARCHAR2(250) NOT NULL,
    DSUSUARIOBANCO   VARCHAR2(100),
    DSSENHABANCO     VARCHAR2(100),
    IDCOLETOR        VARCHAR2(100) NOT NULL,
    IDUTWALLET       VARCHAR2(1)   DEFAULT 'N' NOT NULL,
    IDTPBANCO        VARCHAR2(25)  DEFAULT 'ORACLE' NOT NULL,     
    NRORG             NUMBER 	   DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO           VARCHAR2(1)  DEFAULT 'S' NOT NULL,
    DTINCLUSAO        DATE         DEFAULT SYSDATE,
    DTULTATU          DATE         DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')	NULL,
    CDOPERINCLUSAO    VARCHAR2(12) DEFAULT '1' NULL,
    NRORGULTATU       NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')	NULL,
    CDOPERULTATU      VARCHAR2(12) DEFAULT '1',
    CONSTRAINT PK_OM_PRODUTO_ORG_COLETOR    PRIMARY KEY(ID),
    CONSTRAINT CKC_IDATIVO_OM_PROD_ORG_COLE CHECK (IDATIVO IN ('S','N'))
)
/

ALTER TABLE OM_PRODUTO_ORG_COLETOR ADD CONSTRAINT FK_OM_PROD_ORG_OM_PROD_COLE  
	FOREIGN KEY (NRPRODUTO_ORG_ID) REFERENCES OM_PRODUTO_ORG (ID)
/

CREATE INDEX FK_OM_PROD_ORG_OM_PROD_COLE ON OM_PRODUTO_ORG_COLETOR (NRPRODUTO_ORG_ID ASC)
/

CREATE TABLE IDEAL_4FORN
( 
  NRIDEAL4FORN        NUMBER,
  NRSEQEMISSAO        VARCHAR2(10),
  NRPAGINA            NUMBER,
  CDREGIAO            VARCHAR2(3),
  NMREGIAO            VARCHAR2(30),
  NMOPERADOR          VARCHAR2(40),
  CDOPERADOR          VARCHAR2(12),
  CDPRODUTO           VARCHAR2(10),
  NMPRODUTO           VARCHAR2(50),
  CDARVPROD           VARCHAR2(20),
  SGUNIDADE           VARCHAR2(10),
  CDMARCA             VARCHAR2(5),
  NMMARCA             VARCHAR2(20),
  DTINI               DATE,
  DTFIN               DATE,
  NMFANTFORN_AF_ANT   VARCHAR2(40),
  IDTPIJURFORN_AF_ANT VARCHAR2(1),
  NRINSJURFORN_AF_ANT VARCHAR2(20),
  VRPREUNIAF_AF_ANT   FLOAT(126),
  QTACOMPRAR          FLOAT(126),
  NMFANTFORN_MIX      VARCHAR2(40),
  IDTPIJURFORN_MIX    VARCHAR2(1),
  NRINSJURFORN_MIX    VARCHAR2(20),
  VRPRECUNIITM_MIX    FLOAT(126),
  VRPRECENT_MIX       FLOAT(126),
  VALOR_TORAL_MIX     FLOAT(126),
  CDMARCA_MIX         VARCHAR2(5),
  NMMARCA_MIX         VARCHAR2(20),
  NMFANTFORN1         VARCHAR2(40),
  CDFORNECED1         VARCHAR2(21),
  IDTPIJURFORN1       VARCHAR2(1),
  NRINSJURFORN1       VARCHAR2(20),
  VRTOTAL_FORN1       FLOAT(126),
  VRPRECUNIITM1       FLOAT(126),
  VALOR_TORAL_ITM1    FLOAT(126),
  VRPRECENT1          FLOAT(126),
  NMFANTFORN2         VARCHAR2(40),
  CDFORNECED2         VARCHAR2(21),
  IDTPIJURFORN2       VARCHAR2(1),
  NRINSJURFORN2       VARCHAR2(20),
  VRTOTAL_FORN2       FLOAT(126),
  VRPRECUNIITM2       FLOAT(126),
  VALOR_TORAL_ITM2    FLOAT(126),
  VRPRECENT2          FLOAT(126),
  NMFANTFORN3         VARCHAR2(40),
  CDFORNECED3         VARCHAR2(21),
  IDTPIJURFORN3       VARCHAR2(1),
  NRINSJURFORN3       VARCHAR2(20),
  VRTOTAL_FORN3       FLOAT(126),
  VRPRECUNIITM3       FLOAT(126),
  VALOR_TORAL_ITM3    FLOAT(126),
  VRPRECENT3          FLOAT(126),
  NMFANTFORN4         VARCHAR2(40),
  CDFORNECED4         VARCHAR2(21),
  IDTPIJURFORN4       VARCHAR2(1),
  NRINSJURFORN4       VARCHAR2(20),
  VRTOTAL_FORN4       FLOAT(126),
  VRPRECUNIITM4       FLOAT(126),
  VALOR_TORAL_ITM4    FLOAT(126),
  VRPRECENT4          FLOAT(126), 
	CONSTRAINT PK_IDEAL_4FORN PRIMARY KEY(NRIDEAL4FORN),
  NRORG             NUMBER 	      	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
  IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
  DTINCLUSAO        DATE            DEFAULT SYSDATE,
  DTULTATU          DATE            DEFAULT SYSDATE,
  NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
  CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
  NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
  CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
	CONSTRAINT CKC_IDATIVO_IDEAL_4FORN CHECK (IDATIVO IN ('S','N'))
)
/

ALTER TABLE IDEAL_4FORN ADD CONSTRAINT IDEAL_4FORN_CB UNIQUE (NRSEQEMISSAO, NRPAGINA, CDREGIAO, CDOPERADOR, CDPRODUTO)
/

CREATE TABLE OM_PRODUTO_ELEMENTO_ORG_ESPEC (
    ID                    NUMBER NOT NULL,
    NRORG_ID              NUMBER NOT NULL,
    NRPRODUTO_ELEMENTO_ID NUMBER NOT NULL,
    NRORG             NUMBER 	   DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO           VARCHAR2(1)  DEFAULT 'S' NOT NULL,
    DTINCLUSAO        DATE		   DEFAULT SYSDATE,
    DTULTATU          DATE		   DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERINCLUSAO    VARCHAR2(12) DEFAULT '1',
    NRORGULTATU       NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERULTATU      VARCHAR2(12) DEFAULT '1',
    CONSTRAINT PK_OM_PROD_ELEMENTO_ORG_ESPEC  PRIMARY KEY(ID),
    CONSTRAINT CKC_IDATIVO_OM_PROD_ELE_ORG    CHECK (IDATIVO IN ('S','N'))
)
/

ALTER TABLE OM_PRODUTO_ELEMENTO_ORG_ESPEC ADD CONSTRAINT FK_OM_PROD_ELE_OM_PROD_ELE_ORG FOREIGN KEY (NRPRODUTO_ELEMENTO_ID) REFERENCES OM_PRODUTO_ELEMENTO (ID)
/

ALTER TABLE OM_PRODUTO_ELEMENTO_ORG_ESPEC ADD CONSTRAINT FK_OM_PROD_ELE_ORGANIZACAO     FOREIGN KEY (NRORG_ID) REFERENCES ORGANIZACAO (NRORG)
/

ALTER TABLE OM_PRODUTO_ELEMENTO ADD IDELEMENTOPADRAO VARCHAR2(1) DEFAULT 'N' NOT NULL
/

ALTER TABLE OM_PRODUTO_ELEMENTO ADD CONSTRAINT CKC_IDELEPADRAO_OM_PROD_ELE CHECK (IDELEMENTOPADRAO IN ('S','N'))
/

CREATE TABLE CP_ORG_FILIAL (
    ID       NUMBER      NOT NULL,
    NRORG_ID NUMBER      NOT NULL,
    CDFILIAL VARCHAR2(4) NOT NULL,
    NRORG          NUMBER 	    DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO        VARCHAR2(1)  DEFAULT 'S' NOT NULL,
    DTINCLUSAO     DATE		    DEFAULT SYSDATE,
    DTULTATU       DATE		    DEFAULT SYSDATE,
    NRORGINCLUSAO  NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1',
    NRORGULTATU    NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERULTATU   VARCHAR2(12) DEFAULT '1',    
    CONSTRAINT PK_CP_ORG_FILIAL          PRIMARY KEY(ID),
    CONSTRAINT CKC_IDATIVO_CP_ORG_FILIAL CHECK (IDATIVO IN ('S','N'))
)
/

ALTER TABLE CP_ORG_FILIAL ADD CONSTRAINT FK_CP_ORG_FILIAL_ORG      
	FOREIGN KEY (NRORG_ID) REFERENCES ORGANIZACAO (NRORG)
/

ALTER TABLE CP_ORG_FILIAL ADD CONSTRAINT FK_CP_ORG_FILIAL_FILI     
	FOREIGN KEY (CDFILIAL) REFERENCES FILIAL (CDFILIAL)
/

CREATE TABLE ERROS_COLETA (
    ID             NUMBER        NOT NULL,
    SERVIDOR       VARCHAR2(500) NOT NULL,
    NRORG_ID       NUMBER        NOT NULL,
    CDTPMEDIDASERV NUMBER        NOT NULL,
    NRSEQCONTRATO  NUMBER        NOT NULL,
    CDSERVORCA     NUMBER,
    PRODUCT_ID     NUMBER,
    ERRO_COLETA    CLOB,
    DTINICOMPET    DATE,
    DTFINCOMPET    DATE,    
    NRORG          NUMBER 	    DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO        VARCHAR2(1)  DEFAULT 'S' NOT NULL,
    DTINCLUSAO     DATE		    DEFAULT SYSDATE,
    DTULTATU       DATE		    DEFAULT SYSDATE,
    NRORGINCLUSAO  NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1',
    NRORGULTATU    NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERULTATU   VARCHAR2(12) DEFAULT '1',   
    CONSTRAINT PK_ERROS_COLETA          PRIMARY KEY(ID),
    CONSTRAINT CKC_IDATIVO_ERROS_COLETA CHECK (IDATIVO IN ('S','N'))
)
/

ALTER TABLE ERROS_COLETA ADD CONSTRAINT FK_CP_ORG_FILIAL_ORGA  
	FOREIGN KEY (NRORG_ID) REFERENCES ORGANIZACAO (NRORG)
/

ALTER TABLE ERROS_COLETA ADD CONSTRAINT FK_CP_ORG_FILIAL_MEDV    
	FOREIGN KEY (CDTPMEDIDASERV) REFERENCES FCT_TIPOMEDIDASERV (CDTPMEDIDASERV)
/
	
ALTER TABLE ERROS_COLETA ADD CONSTRAINT FK_CP_ORG_FILIAL_SEQC    
	FOREIGN KEY (NRSEQCONTRATO) REFERENCES FCT_CONTRATO (NRSEQCONTRATO)
/
	
ALTER TABLE ERROS_COLETA ADD CONSTRAINT FK_CP_ORG_FILIAL_SERV    
	FOREIGN KEY (CDSERVORCA) REFERENCES FCT_SERVICOORCA (CDSERVORCA)
/
	
ALTER TABLE ERROS_COLETA ADD CONSTRAINT FK_CP_ORG_FILIAL_PROD    
	FOREIGN KEY (PRODUCT_ID) REFERENCES PRODUCT (ID)
/

CREATE TABLE PERFILACESSO_LABEL (
    ID             	  NUMBER 		NOT NULL,
    LABEL          	  VARCHAR2(500) NOT NULL,
    NRPERFILACESSO 	  NUMBER 		NOT NULL,
    NRORG             NUMBER 	   DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO           VARCHAR2(1)  DEFAULT 'S' NOT NULL,
    DTINCLUSAO        DATE		   DEFAULT SYSDATE,
    DTULTATU          DATE		   DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERINCLUSAO    VARCHAR2(12) DEFAULT '1',
    NRORGULTATU       NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERULTATU      VARCHAR2(12) DEFAULT '1',
    CONSTRAINT PK_PERFILACESSO_LABEL      PRIMARY KEY(ID),
    CONSTRAINT FK_PERFILACESSO_LABEL_PERF FOREIGN KEY (NRPERFILACESSO) REFERENCES PERFILACESSO (NRPERFILACESSO),
    CONSTRAINT CKC_IDATIVO_PERFACES_LABEL CHECK (IDATIVO IN ('S','N'))
)
/

CREATE INDEX FK_PERFILACESSO_LABEL_PERF ON PERFILACESSO_LABEL (NRPERFILACESSO ASC)
/

CREATE TABLE OPERADOR_LABEL_VERSAO (
    ID             NUMBER 		NOT NULL,
    PRODUCT_ID     NUMBER 		NOT NULL,
    CDOPERADOR     VARCHAR2(12) NOT NULL,
    NRULTVERSAO    NUMBER 		NOT NULL,
    NRORG          NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO        VARCHAR2(1)  DEFAULT 'S' NOT NULL,
    DTINCLUSAO     DATE         DEFAULT SYSDATE,
    DTULTATU       DATE         DEFAULT SYSDATE,
    NRORGINCLUSAO  NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1',
    NRORGULTATU    NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg'),
    CDOPERULTATU   VARCHAR2(12) DEFAULT '1',
    CONSTRAINT PK_OPERADOR_LABEL_VERSAO PRIMARY KEY(ID),
    CONSTRAINT FK_OPER_OPER_LABEL_VERSAO FOREIGN KEY (CDOPERADOR) REFERENCES OPERADOR (CDOPERADOR),
    CONSTRAINT CKC_IDATIVO_OPER_LABEL_VER CHECK (IDATIVO IN ('S','N'))
)
/
CREATE INDEX FK_OPER_OPER_LABEL_VERSAO ON OPERADOR_LABEL_VERSAO (CDOPERADOR ASC)
/

ALTER TABLE PERFILACESSO_LABEL ADD NMMENU VARCHAR2(500)
/

ALTER TABLE ERROS_COLETA ADD DTULTCOLETASUC DATE
/

 CREATE TABLE PRIORIZAOLFILDEST
(
NRPRIORIZAOLFILDEST NUMBER 		NOT NULL,
CDFILIOPELOG 	VARCHAR2(4) 	NOT NULL, 
CDFILDEST     	VARCHAR2(4) 	NOT NULL, 
NRPRIORIDADE 	NUMBER 			NOT NULL,     
NRORG           NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
IDATIVO         VARCHAR2(1)  	DEFAULT 'S' NOT NULL
CONSTRAINT CKC_IDATIVO_PRIORIZAOLFILDEST CHECK (IDATIVO IN ('S','N')),  
DTINCLUSAO      DATE            DEFAULT SYSDATE,
CDOPERINCLUSAO  VARCHAR2(12) 	DEFAULT '1' NULL,
DTULTATU        DATE            DEFAULT SYSDATE,
NRORGINCLUSAO   NUMBER       	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')   NULL,
NRORGULTATU     NUMBER       	DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')   NULL,
CDOPERULTATU    VARCHAR2(12) 	DEFAULT '1' NULL, 
CONSTRAINT PK_NRPRIORIZAOLFILDEST PRIMARY KEY(NRPRIORIZAOLFILDEST)
)
/

ALTER TABLE PRIORIZAOLFILDEST ADD CONSTRAINT UN_PRIORIZAOLFILDEST UNIQUE (NRPRIORIZAOLFILDEST, CDFILIOPELOG, CDFILDEST, NRPRIORIDADE)
/

ALTER TABLE PRIORIZAOLFILDEST ADD CONSTRAINT FKOPL00002FILIAL FOREIGN KEY (CDFILIOPELOG) REFERENCES FILIAL(CDFILIAL)
/

ALTER TABLE PRIORIZAOLFILDEST ADD CONSTRAINT FKOPL00003FILIAL FOREIGN KEY (CDFILDEST) REFERENCES FILIAL(CDFILIAL)
/

CREATE INDEX FKOPL00002FILIAL ON PRIORIZAOLFILDEST (CDFILIOPELOG)
/

CREATE INDEX FKOPL00003FILIAL ON PRIORIZAOLFILDEST (CDFILDEST)
/